%lpcan
%M-file
%AR novembre 1996

echo on
clc
echo off

sigstr = input('Introduce the filename of a signal to be processed (*.aif or *.sig): ', 's');
if isempty(sigstr), sigstr = 'cane.aif'; end

fid=fopen(sigstr);
sigtemp = fread(fid,inf,'int16');
sigtempsize = size(sigtemp,1);

sigrange=11:sigtempsize-256;
sig = sigtemp(sigrange);
clear('sigrange');
sigsize = size(sig,1);
xrange=[0 sigsize];
yrange=[-36000 36000];
ax=[xrange yrange];
xint=1:length(sig)';

figure(1)
set(gcf,'Position',[1 800 600 302],'Resize','on')
clf
subplot(1,1,1),plot(xint,sig,'y-'),axis(ax)

saxis('auto');
sound(sig/max(sig),16000);

nbr=sigsize/256;
amat=0;

for count=1:nbr;

sigzoom=sig(256*(count-1)+1:256*count);

x=0;
x=find(sigzoom>0);
if isempty(x); sigzoom=1; end;

a=lpc(sigzoom,20);
amat(count,1:21)=a(1:21);
sigzoomzero = [sigzoom;zeros(20,1)];
e = filter(a,1,sigzoomzero);
G = sqrt(e'*e);
amat(count,22)=G;

end; % main loop
