%VUNV.m version c
%bas sur voice.m (octobre 1996 puis vunv.m) AR mai 2002 - aout 2003
echo on
% permette di determinare su un oscillogramma
% delle aree di sonorit in cui andare a misurare F0
echo off

signame = input('File audio [test.wav]: ', 's');
if isempty(signame), signame = 'test.wav'; end

fid=fopen(signame);
sigtemp = fread(fid,inf,'int16');
sigtempsize = size(sigtemp,1);
fclose(fid);

sig = sigtemp(30:sigtempsize-256);
sigsize = size(sig,1);
xrange=[0 sigsize];
yrange=[-36000 36000];
ax=[xrange yrange];

clear('sigtemp');

figure(1)
set(gcf,'Position',[10 471 678 255],'Resize','on')
%set(gcf,'Position',[10 571 678 255],'Resize','on')
%set(gcf,'Position',[10 563 1082 263],'Resize','on')
clf

subplot(1,1,1),plot(sig,'b-'),axis(ax)
signamesize=size(signame,2);
if signame(signamesize)=='f' & signame(signamesize-1)=='i' & signame(signamesize-2)=='a';
	title(signame(1:signamesize-4));
else title(signame); end;

xlabel('smpls [ ]');
ylabel('amplitude [ ]');

sig2=sig/max(sig);
sound(sig2,16000,16);
%saxis('auto');
%sound(sig2,16000);

text(-sigsize/6,20000,'play to');
text(-sigsize/6,0,'play');
text(-sigsize/6,-20000,'play from');
text(-sigsize/6,39000,'erase');

	message=sprintf('%s','Cliccare sull''oscill. per delimitare le aree di misura')
	clickflag=1;
	i=1;
	block=0;
	blockf=0;
	while clickflag==1;
		x1 = ginput(1);

		%saxis('auto');
		if x1(1)<-0.1 & x1(2)>10000 & x1(2)<30000;
			%saxis('auto');
			if block==0;
				land=sigsize;
			end;
			sound(sig2(1:land), 16000); 
		elseif x1(1)<-0.1 & x1(2)<5000 & x1(2)>-5000 ;
			%saxis('auto');
			if block==0;
				sound(sig2, 16000); 
			else
				sound(sig2(floor(block(i-2)):land), 16000); 
			end;
		elseif x1(1)<-0.1 & x1(2)<-10000 ; 
			%saxis('auto');
			if block==0;
				land=1;
			end;
			sound(sig2(land:sigsize),16000); 
		elseif x1(1)<-0.1 & x1(2)>30000 ; 
			xxx(1)=block(i-1);
			xxx(2)=block(i-1);
			subplot(1,1,1),hold on,plot(xxx,yrange,'w:','erase','none'),hold off
			i=i-1;
		end;

		if x1(1)>0.1 & x1(1)<sigsize;
        		block(i)=x1(1);
         		blockf(i)=0;
			land=x1(1);
			i=i+1;
		end;
     
		if i>1;
			xxx(1)=block(i-1);
			xxx(2)=block(i-1);
		end;
         
      if x1(1)>0.1 & x1(1)<sigsize & x1(2)<30000 ;
			subplot(1,1,1),hold on,plot(xxx,yrange,'r:','erase','none'),hold off
      elseif x1(1)>0.1 & x1(1)<sigsize & x1(2)>30000 ; 
			subplot(1,1,1),hold on,plot(xxx,yrange,'b:','erase','none'),hold off
         blockf(i-1)=block(i-1);
		end;   
      
      if x1(1)>sigsize;
			clickflag=0;
		end;
   end;
   
	block=sort(block);
	nbr=size(block,2);
	voiced=zeros(1,sigsize);
	  for j=1:nbr/2;
		for i=floor(block(2*j-1)):floor(block(2*j));
         if floor(blockf(2*j-1))<1
            voiced(i)=10000; 
         else
            voiced(i)=-10000;
         end;
		end;	  
	  end;
	subplot(1,1,1),hold on,plot(voiced,'y'),axis(ax),hold off

signamesize=size(signame,2);
if signame(signamesize)=='f' & signame(signamesize-1)=='i' & signame(signamesize-2)=='a';
	title(signame(1:signamesize-4));
else title(signame); end;

ylabel('amplitude []');

maxcount=2*floor(sigsize/160);
erg=zeros(1,maxcount-1);
widerg=zeros(1,sigsize);
count=1;
windsig=sig(1:160);
erg(count)=10*log10(windsig'*windsig+1);
	
for count=2:maxcount-1;
	windsig=sig((count-1)*80+1:(count+1)*80);
	erg(count)=10*log10(windsig'*windsig+1);
end;

for count=1:maxcount-1;
	for i=1:160; widerg((count-1)*80+i)=erg(count); end;
end;

%for i=(maxcount-2)*80:sigsize;
%	widerg(i)=0;
%end;

for i=1:sigsize;
	if widerg(i)<50; widerg(i)=50; end;
end;

ergmax=max(erg);
widergax=[1 sigsize 50 ergmax+10];

for i=1:nbr/2;
	ergval(i)=max(widerg(floor(block(2*i-1)):floor(block(2*i))));
end;

blocknbr=nbr/2;

clear('xrange');
clear('yrange');
clear('message');
clear('clickflag');
clear('fid');
clear('sigtempsize');
clear('erg');
%clear('widerg');

