%model.m  version c
%AR octobre 1996 - aout 2003
echo on
% permette la stilizzazione automatica della curva
% di F0 ottenuta con FOF e corretta con SMOOTH 
% - traccia la curva, ne consente la correzione manuale
% e permette di salvarla in un file .txt
echo off

%fostars=zeros(1,xvectsize);

%for n=1:xvectsize; 
	%tvoiced(n)=t(n);
	%if voiced(xvect(n))<5000 ;
	%	tvoiced(n)=0;
	%end;
%end;

%for n=1:xvectsize; 
	%if tvoiced(n)>0;
	%	fostars(n)=16000/tvoiced(n);
	%end;
%end;

m=1;
on=0;
front(m)=0;
for n=1:xvectsize;
	if (fostars(n)>0); 
		if on<1; front(m)=n; on=1; m=m+1; end;
	else 
		if on>0; front(m)=n-1; on=0; m=m+1; end;
	end;
end;

frontnbr=size(front,2)/2;

for i=1:frontnbr;
	xbeg(i)=front(2*i-1);
	xend(i)=front(2*i);
end;

fomdl=zeros(1,xvectsize);

for i=1:frontnbr;
    flag=1;
    incr1=0;
    sprev=1000000;
    while flag==1;

	%if fostars(xend(i)-1)>0.2*fostars(xend(i)-2); fostars(xend(i)-1)=fostars(xend(i)-2); end;
	%if fostars(xend(i))>0.2*fostars(xend(i)-1); fostars(xend(i))=fostars(xend(i)-1); end;

	fomdl(xbeg(i))=(fostars(xbeg(i))+fostars(xbeg(i)+incr1))/2;
	fomdl(xend(i))=fostars(xend(i));

	for l=1:xend(i)-xbeg(i);
		fomdl(xbeg(i)+l)=fomdl(xbeg(i))+l*(fomdl(xend(i))-fomdl(xbeg(i)))/(xend(i)-xbeg(i));	
	end;

	maxbid=-10000;
	maxl=(xend(i)+xbeg(i))/2-xbeg(i);
	if floor(xend(i)-xbeg(i))>3;
		for l=3:floor(xend(i)-xbeg(i)-3);
			bid(l)=abs(fostars(xbeg(i)+l)-fomdl(xbeg(i)+l));	
			if bid(l)>maxbid; maxbid=bid(l); maxl=l; end;
		end;
	end;
	xmid(i)=xbeg(i)+maxl;
	ymid(i)=fostars(floor(xmid(i)));
	fomdl(floor(xmid(i)))=ymid(i);

	for l=1:floor(xmid(i)-xbeg(i));
		fomdl(xbeg(i)+l)=fomdl(xbeg(i))+l*(ymid(i)-fomdl(xbeg(i)))/(xmid(i)-xbeg(i));	
	end;
	for l=1:floor(xend(i)-xmid(i));
		fomdl(floor(xmid(i))+l)=ymid(i)+l*(fostars(floor(xend(i)))-ymid(i))/(xend(i)-xmid(i));	
	end;

	%hold on, plot(fomdl,'g'), hold off

	s=0;
	for k=floor(xbeg(i)):floor(xend(i));
		s=s+(fostars(k)-fomdl(k))*(fostars(k)-fomdl(k));
	end;

	incr1=incr1+1;

	if s<sprev; flag=1; sprev=s; else flag=0; end;

    end; %while

end;

%modeldata  
% data structure of a .mdl
%
%	blocknbr*6 values of Fo (three pairs of x-values/y-values for each block)
%	sigsize
%	blocknbr values of erg
%	end.
%
% to get blocknbr read data, determine their size (datanbr)
% and calculate (datanbr-1)/7.

datafo=0;
datai=0;
for i=1:blocknbr;
   if blockf(2*i-1)<1 & blockf(2*i)<1

      datai=datai+1;
	datafo(6*i-5)=block(2*i-1);
      datafo(6*i-4)=fomdl(xbeg(datai));		
      
	datafo(6*i-3)=block(2*i-1)+(xmid(datai)-xbeg(datai))*((block(2*i)-block(2*i-1))/(xend(datai)-xbeg(datai)));
	datafo(6*i-2)=fomdl(floor(xmid(datai)));

	datafo(6*i-1)=block(2*i);
      datafo(6*i)=fomdl(xend(datai));

   else

      %datai=datai+1;
      datafo(6*i-5)=(blockf(2*i-1)+blockf(2*i))/2;
      datafo(6*i-4)=50;		
      
      datafo(6*i-3)=(blockf(2*i-1)+blockf(2*i))/2;
	datafo(6*i-2)=50;

	datafo(6*i-1)=(blockf(2*i-1)+blockf(2*i))/2;
      datafo(6*i)=50;
    
   end;
end;
datafo(6*blocknbr+1)=sigsize;

for i=1:blocknbr;
	if blockf(2*i-1)<1 & blockf(2*i)<1
		datafo(6*blocknbr+1+i)=ergval(i);
   	else
		datafo(6*blocknbr+1+i)=0;
	end;
end;

%%%%%%%%%%%%%%%%%%ExTEND & PLOT%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	data=datafo;

	datanbr=size(data,2);
	datanbr=datanbr-blocknbr;

	datafox(1)=0;
	datafoy(1)=0;
	for i=2:(datanbr-1)/2+1;
		datafox(i)=data(2*(i-1)-1);
		datafoy(i)=data(2*(i-1));
	end;
	datafox((datanbr-1)/2+2)=data(datanbr);
	datafoy((datanbr-1)/2+2)=0;

	sigsize=datafox((datanbr-1)/2+2);

	fo5=zeros(1,sigsize);
	for i=2:floor((datanbr-1)/2+1);
		fo5(floor(datafox(i)))=datafoy(i);
	end;

	for i=1:floor((datanbr-1)/6);
		for j=floor(datafox(3*i-1)+1):floor(datafox(3*i));
			fo5(j)=fo5(floor(datafox(3*i-1)))+(j-datafox(3*i-1)+1)*(fo5(floor(datafox(3*i)))-fo5(floor(datafox(3*i-1))))/(datafox(3*i)-datafox(3*i-1));
		end;
		for j=floor(datafox(3*i)+1):floor(datafox(3*i+1));
			fo5(j)=fo5(floor(datafox(3*i)))+(j-datafox(3*i)+1)*(fo5(floor(datafox(3*i+1)))-fo5(floor(datafox(3*i))))/(datafox(3*i+1)-datafox(3*i));
		end;
	end;

	figure(2)
	set(gcf,'Position',[4 273 681 123],'Resize','on')
	clf;
	fomax=max(fo5);
	yrange=[-40 fomax+50];
	tax=[1 sigsize yrange];
	plot(fo5(1:sigsize),'r-'),axis(tax)

%%%%%%%%%%%%%%%%%CORRECT%%%%%%%%%%%%%%%%%%%%%%%%%%%%

changeflag=0;
changeflag = input('Correggere? (y/n) [default y]: ', 's');
if isempty(changeflag), changeflag = 'y'; end;

while changeflag == 'y';

	chbk=0;
	chbk = input('Quale vocale? (Numero) ');

	format bank;
	datax = [datafo(6*chbk-5) datafo(6*chbk-3) datafo(6*chbk-1)]
	datay = [datafo(6*chbk-4) datafo(6*chbk-2) datafo(6*chbk)]
	
	nv1=0;
	nv2=0;
	nv3=0;
	nv1 = input('Nuovo valore per Fo1? [default: prec.] ');	
	if isempty(nv1), nv1 = datafo(6*chbk-4); end;
	datafo(6*chbk-4) = nv1;

	nv2 = input('Nuovo valore per Fo2? [default: prec.] ');	
	if isempty(nv2), nv2 = datafo(6*chbk-2); end;
	datafo(6*chbk-2) = nv2;

	nv3 = input('Nuovo valore per Fo3? [default: prec.] ');	
	if isempty(nv3), nv3 = datafo(6*chbk); end;
	datafo(6*chbk) = nv3;

	data=datafo;

	datanbr=size(data,2);
	blocknbr4=(datanbr-1)/7;
	datanbr=datanbr-blocknbr4;

	datafox(1)=0;
	datafoy(1)=0;
	for i=2:(datanbr-1)/2+1;
		datafox(i)=data(2*(i-1)-1);
		datafoy(i)=data(2*(i-1));
	end;
	datafox((datanbr-1)/2+2)=data(datanbr);
	datafoy((datanbr-1)/2+2)=0;

	sigsize=datafox((datanbr-1)/2+2);

	fomax=max(datafoy);
	yrange=[-40 fomax+50];
	tax=[1 sigsize yrange];
	%plot(datafox,datafoy,'o'),axis(tax)

	fo5=zeros(1,sigsize);
	for i=2:floor((datanbr-1)/2+1);
		fo5(floor(datafox(i)))=datafoy(i);
	end;

	for i=1:floor((datanbr-1)/6);
		for j=floor(datafox(3*i-1)+1):floor(datafox(3*i));
			fo5(j)=fo5(floor(datafox(3*i-1)))+(j-datafox(3*i-1)+1)*(fo5(floor(datafox(3*i)))-fo5(floor(datafox(3*i-1))))/(datafox(3*i)-datafox(3*i-1));
		end;
		for j=floor(datafox(3*i)+1):floor(datafox(3*i+1));
			fo5(j)=fo5(floor(datafox(3*i)))+(j-datafox(3*i)+1)*(fo5(floor(datafox(3*i+1)))-fo5(floor(datafox(3*i))))/(datafox(3*i+1)-datafox(3*i));
		end;
	end;

	figure(3)
	set(gcf,'Position',[4 273 681 123],'Resize','on')
	clf;
	fomax=max(fo5);
	yrange=[-40 fomax+50];
	tax=[1 sigsize yrange];
	plot(fo5(1:sigsize),'r-'),axis(tax)

	changeflag = input('Correggere altri valori? (y/n) [default y]: ', 's');
	if isempty(changeflag), changeflag = 'y'; end;

end;

datanbr=size(datafo,2);
blocknbr5=(datanbr-1)/7;
datanbr=datanbr-blocknbr5;

datafox(1)=0;
datafoy(1)=0;
for i=2:floor((datanbr-1)/2+1);
	datafox(i)=datafo(2*(i-1)-1);
	datafoy(i)=datafo(2*(i-1));
end;
datafox((datanbr-1)/2+2)=datafo(datanbr);
datafoy((datanbr-1)/2+2)=0;

sigsize=datafox((datanbr-1)/2+2);

for i=1:blocknbr5;
	ergval(i)=datafo(datanbr+i);
end;

saveflag=0;
saveflag = input('Salvare il modello in un file di testo? (y/n) [default y]: ', 's');
if isempty(saveflag), saveflag = 'y'; end;

if saveflag == 'y';
	whichfile = input('File? (*.txt) [default xxxxx.txt]: ', 's');
	filename=whichfile;
	if isempty(filename), filename='xxxxx.txt'; end;

	fid = fopen(filename,'w');
	fprintf(fid,'%s\t',filename);
	fprintf(fid,'%s ','size:');
	fprintf(fid,'%d\n',sigsize);
	datestr=date;
	fprintf(fid,'%s\n\n',datestr);
	fprintf(fid,'\t\t\t%s\t\t%s\t\t%s\t%s\t%s\n\n','duration [ms]','energy [dB]','fo1','fo2','fo3 [Hz]');
	for i=1:blocknbr5; 
		fprintf(fid,'%2d\t\t\t\t',i); 
		fprintf(fid,'%3.0f\t\t\t', (datafox(3*i+1)-datafox(3*i-1))/16); 
		fprintf(fid,'%3.0f\t\t',ergval(i)); 
		fprintf(fid,'%4.0f\t',datafoy(3*i-1)); 
		fprintf(fid,'%4.0f\t',datafoy(3*i)); 
		fprintf(fid,'%4.0f\n',datafoy(3*i+1)); 
	end;

	fprintf(fid,'\n%s\n', 'values at:'); 
	for i=2:blocknbr5*3+1; 
		fprintf(fid,'%3.0f ', datafox(i)); 
	end;

	fclose(fid);
end;

clear('flag');
clear('bid');
clear('blockcount');
%clear('fostars');
%clear('fomdl');
%clear('front');
clear('data');
