%open a report file (*.rep)
%M-file
%AR fevrier 1998

clear all;
data=0;
datafox=0;
datafoy=0;
sigsize=0;
ergval=0;

signame = input('Introduce the name of the file to be opened (*.rep): ', 's');
if isempty(signame), signame = 'a.rep'; end

fid = fopen(signame,'r');
filestr=fscanf(fid,'%s',1);
sizestr=fscanf(fid,'%s',1);
sigsiz=fscanf(fid,'%d',1);
datestr=fscanf(fid,'%s',1);
mnstr=fscanf(fid,'%s',1);
dstr=fscanf(fid,'%s',1);
msstr=fscanf(fid,'%s',1);
mnstr=fscanf(fid,'%s',1);
enstr=fscanf(fid,'%s',1);
dBstr=fscanf(fid,'%s',1);
mnstr=fscanf(fid,'%s',1);
fo1str=fscanf(fid,'%s',1);
mnstr=fscanf(fid,'%s',1);
fo2str=fscanf(fid,'%s',1);
mnstr=fscanf(fid,'%s',1);
fo3str=fscanf(fid,'%s',1);
Hzstr=fscanf(fid,'%s',1);

data=fscanf(fid,'%d');

otherstr=fscanf(fid,'%s',1);
otherstr=fscanf(fid,'%s',1);
datax=fscanf(fid,'%d');

fclose(fid);

datasize=size(data,1);
blocknbr=datasize/12;
dataout=0;

for i=1:blocknbr;
	block(i)=data((i-1)*6+6*i-5);
	durations(i)=data((i-1)*6+6*i-4);
	energies(i)=data((i-1)*6+6*i-3);
	datay(3*i-2)=data((i-1)*6+6*i-2);
	datay(3*i-1)=data((i-1)*6+6*i-1);
	datay(3*i)=data((i-1)*6+6*i);
	blockv(i)=data(i*6+6*i-5);
	durationsv(i)=data(i*6+6*i-4);
	energiesv(i)=data(i*6+6*i-3);
	datayv(3*i-2)=data(i*6+6*i-2);
	datayv(3*i-1)=data(i*6+6*i-1);
	datayv(3*i)=data(i*6+6*i);
end;

for i=1:blocknbr*3;
	dataout(2*i-1)=datax(i);
	dataout(2*i)=datay(i);
end;

dataout(blocknbr*6+1)=sigsiz;
for k=1:blocknbr;
	dataout(blocknbr*6+1+k)=energies(k);
end;

datanbr=size(dataout,2);
blocknbr=(datanbr-1)/7;
datanbr=datanbr-blocknbr;

datafox(1,1)=0;
datafoy(1,1)=0;
for i=2:(datanbr-1)/2+1;
	datafox(1,i)=dataout(2*(i-1)-1);
	datafoy(1,i)=dataout(2*(i-1));
end;
datafox(1,(datanbr-1)/2+2)=dataout(datanbr);
datafoy(1,(datanbr-1)/2+2)=0;

sigsize(1)=datafox(1,(datanbr-1)/2+2);

for i=1:blocknbr;
	ergval(1,i)=dataout(datanbr+i);
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

filename=filestr;
%detstr;

saveflag2=0;
saveflag2 = input('Would you like to save a txtfile? (y/n) [default y]: ', 's');
if isempty(saveflag2), saveflag2 = 'y'; end;

if saveflag2 == 'y';
   strsize=size(filename,2);
   txtfilename= [filename(1:strsize-4) '0' '.' 't' 'x' 't'];
	fid = fopen(txtfilename,'w');
	fprintf(fid,'%s\t',txtfilename);
	fprintf(fid,'%s ','size:');
	fprintf(fid,'%d\n',sigsize);
	datestr=date;
	fprintf(fid,'%s\n\n',datestr);
	fprintf(fid,'\t\t\t%s\t\t%s\t\t%s\t%s\t%s\n\n','duration [ms]','energy [dB]','fo1','fo2','fo3 [Hz]');
	for i=1:blocknbr; 
		fprintf(fid,'%2d\t\t\t\t',i); 
		fprintf(fid,'%3.0f\t\t\t', (datafox(3*i+1)-datafox(3*i-1))/16); 
		fprintf(fid,'%3.0f\t\t',ergval(i)); 
		fprintf(fid,'%4.0f\t',datafoy(3*i-1)); 
		fprintf(fid,'%4.0f\t',datafoy(3*i)); 
		fprintf(fid,'%4.0f\n',datafoy(3*i+1)); 
	end;

	fprintf(fid,'\n%s\n', 'values at:'); 
	for i=2:blocknbr*3+1; 
		fprintf(fid,'%3.0f ', datafox(i)); 
	end;

	fclose(fid);
end;

clear('flag');
clear('bid');
clear('blockcount');
clear('fo3');
clear('data');


